from fractions import Fraction
from __encontrar_N import encontrar_N
from __encontrar_N_zeta import encontrar_N_zeta
from __minimo import minimo


def crear_evaluar (largo, bits, N_limite):
	def evaluar (zeta):
		n = encontrar_N_zeta (largo, zeta, bits, mostrar=False)
		valido = (n != None and n <= N_limite)
		return valido
	return evaluar


def encontrar_zetaAproxVer (largo, bits, tolerancia=Fraction ('15/10'), mostrar=False):
	N = encontrar_N (largo, bits)
	N_limite = N + N * tolerancia / 100
	evaluar = crear_evaluar (largo, bits, N_limite)
	zeta = minimo (evaluar, mostrar)
	return zeta


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 128
	largo = 64
	tolerancia = Fraction ('15/10')

	zeta = encontrar_zetaAproxVer (largo, bits, tolerancia)

	print ('bits, largo = ' + str ((bits, largo)))
	print ('tolerancia = ' + str (tolerancia))
	print ('zeta = ' + str (zeta))

