import os
from hashlib import sha256, sha512
from __aplicarUps import aplicarUps
from __expandir import expandir


def crearfuncion_claves (bits, grupo, split, zA, zB, zCheck, consal, upbits):

	largoB = bits // grupo
	zetas = (zCheck, ) * split + (zA, ) + (zB, ) * largoB
	largo = len (zetas)

	def crearclaves ():
		sal = sha256 (os.urandom (64)).digest () if consal else b''

		seed = sha512 (os.urandom (128)).digest ()
		clavepriv = expandir (seed, upbits, largo)

		clavepub = aplicarUps (clavepriv, ups=zetas, sal=sal, inicio=True, zetas=zetas)

		priv = {'clave': clavepriv, 'sal': sal}
		return priv, clavepub

	return crearclaves


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits, grupo, split = 10, 4, 1
	zA, zB, zCheck = 10, 10, 10

	crearclaves = crearfuncion_claves (bits, grupo, split, zA, zB, zCheck, consal=False, upbits=64)
	priv, pub = crearclaves ()

	print ('priv = ' + repr (priv))
	print ('pub = ' + repr (pub))

